#!/usr/bin/perl -w

use Data::Dumper;
use File::stat;
use lib "/srv/www/htdocs/cacti/scripts";
use query_nmon;

if(!exists($ARGV[0])) {
	print "usage:\n\n";
	print "./nmon_cpustats.pl <hostname>\n";
	exit;
}

my $debug = 0;

my $servername = $ARGV[0];

my $nmondir = "/usr/net/bin/nmon/";
my $cachedir = "/var/cache/cacti/";
my $cachefile = $cachedir . $servername;
my $ssh_idfile = "/home/cacti/.ssh/id_rsa";
my $nmon_runmode = "daemon";

check_and_update_cache($cachefile,$servername,$nmondir,$ssh_idfile,$debug,$nmon_runmode);

open(NMONFILE, $cachefile);

foreach $line (<NMONFILE>) {
        if (my ($type,$values_str) = $line =~ /^(CPU_ALL),T\d{4},(.+)$/) {
		#CPU_ALL,T0314,3.0,1.3,0.3,95.4,,8

		print "$line\n" if($debug > 1);

		my @values = split(/,/,$values_str);

		print "cpu_user:$values[0] cpu_system:$values[1] cpu_wait:$values[2] cpu_idle:$values[3] num_cpu:$values[5]";
	}
}
print "\n";

