#!/usr/bin/perl -w

use Data::Dumper;
use File::stat;
use lib "/srv/www/htdocs/cacti/scripts";
use query_nmon;

if(!exists($ARGV[0])) {
	print "usage:\n\n";
	print "./nmon_lparstats.pl <hostname>\n";
	exit;
}

my $debug = 0;

my $servername = $ARGV[0];

my $nmondir = "/usr/net/bin/nmon/";
my $cachedir = "/var/cache/cacti/";
my $cachefile = $cachedir . $servername;
my $ssh_idfile = "/home/cacti/.ssh/id_rsa";

my $helper = {};

check_and_update_cache($cachefile,$servername,$nmondir,$ssh_idfile,$debug);

open(NMONFILE, $cachefile);

foreach $line (<NMONFILE>) {
        if (my ($type,$description,$attrs_str) = $line =~ /^(LPAR),(Logical\s[^,]+),(.+)$/) {
		#LPAR,Logical Partition azh-550t-1,PhysicalCPU,virtualCPUs,logicalCPUs,poolCPUs,entitled,weight,PoolIdle,usedAllCPU%,usedPoolCPU%,SharedCPU,Capped,EC_User%,EC_Sys%,EC_Wait%,EC_Idle%,VP_User%,VP_Sys%,VP_Wait%,VP_Idle%,Folded,Pool_id

		my @attrs = split(/,/,$attrs_str);

		my $i=0;
		foreach $attr (@attrs) {

			$helper->{$type}->{$i} = $attr;

			print "category: $type - i: $i - attribute: $attr\n" if($debug > 1);

			$i++;
		}
		
	}
        if (my ($type,$values_str) = $line =~ /^(LPAR),T\d{4},(.+)$/) {
		#LPAR,T0001,0.000,2,4,8,0.50,128,0.00,0.00,0.00,1,0,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0

		print "$line\n" if($debug > 1);


		my @values = split(/,/,$values_str);

		$i=0;
		foreach $value (@values) {
			$attr = $helper->{$type}->{$i};
			print "attr: $attr\n" if($debug > 1);
			
			$attr =~ s/\s/_/g;
			$attr =~ s/\%_/pct/g;
			$attr =~ s/(\w)\%/$1_pct/g;
			$attr =~ s/\%(\w)/pct_$1/g;
			$attr =~ s/\%$/pct/g;
			$attr =~ s/\(MB\)/_mb/g;
			$attr =~ s/__/_/g;
			$attr = lc($attr);
			print "$attr:$value ";
			print "attr/value: $attr: $value\n" if($debug > 1);
			$i++;
		}
	}
}
print "\n";

