#!/usr/bin/perl -w

use Data::Dumper;
use File::stat;
use lib "/srv/www/htdocs/cacti/scripts";
use query_nmon;

if(!exists($ARGV[0])) {
	print "usage:\n\n";
	print "./nmon_memstats.pl <hostname>\n";
	exit;
}

my $debug = 0;

my $servername = $ARGV[0];

my $nmondir = "/usr/net/bin/nmon/";
my $cachedir = "/var/cache/cacti/";
my $cachefile = $cachedir . $servername;
my $ssh_idfile = "/home/cacti/.ssh/id_rsa";
my $nmon_runmode = "daemon";

my $helper = {};

check_and_update_cache($cachefile,$servername,$nmondir,$ssh_idfile,$debug,$nmon_runmode);

open(NMONFILE, $cachefile);

foreach $line (<NMONFILE>) {
        if (my ($type,$description,$attrs_str) = $line =~ /^(MEM\w*),(Memory\s[^,]+),(.+)$/) {
		#MEM,Memory azh-550t-1,Real Free %,Virtual free %,Real free(MB),Virtual free(MB),Real total(MB),Virtual total(MB)
		#MEMNEW,Memory New azh-550t-1,Process%,FScache%,System%,Free%,Pinned%,User%
		#MEMUSE,Memory Use azh-550t-1,%numperm,%minperm,%maxperm,minfree,maxfree,%numclient,%maxclient
		#
		#get available netifs and prefill hash

		my @attrs = split(/,/,$attrs_str);

		my $i=0;
		foreach $attr (@attrs) {

			$helper->{$type}->{$i} = $attr;

			print "category: $type - i: $i - attribute: $attr\n" if($debug > 1);

			$i++;
		}
		
	}
        if (my ($type,$values_str) = $line =~ /^(MEM\w*),T\d{4},(.+)$/) {
		#MEM,T0001,3.6,98.7,74.0,1010.2,2048.0,1024.0
		#MEMNEW,T0001,28.2,34.6,33.6,3.6,30.3,59.3
		#MEMUSE,T0001,34.6,9.4,84.7,960,1088,34.6,84.7

		print "$line\n" if($debug > 1);


		my @values = split(/,/,$values_str);

		$i=0;
		foreach $value (@values) {
			$attr = $helper->{$type}->{$i};
			print "attr: $attr\n" if($debug > 1);
			
			$attr =~ s/\s/_/g;
			$attr =~ s/\%_/pct/g;
			$attr =~ s/(\w)\%/$1_pct/g;
			$attr =~ s/\%(\w)/pct_$1/g;
			$attr =~ s/\%$/pct/g;
			$attr =~ s/\(MB\)/_mb/g;
			$attr =~ s/__/_/g;
			$attr = lc($attr);
			print "$attr:$value ";
			print "attr/value: $attr: $value\n" if($debug > 1);
			$i++;
		}
	}
}
print "\n";

