#!/usr/bin/perl -w

use Data::Dumper;
use File::stat;
use lib "/srv/www/htdocs/cacti/scripts";
use query_nmon;

if(!exists($ARGV[0])) {
	print "usage:\n\n";
	print "./nmon_pagestats.pl <hostname>\n";
	exit;
}

my $debug = 0;

my $servername = $ARGV[0];

my $nmondir = "/usr/net/bin/nmon/";
my $cachedir = "/var/cache/cacti/";
my $cachefile = $cachedir . $servername;
my $ssh_idfile = "/home/cacti/.ssh/id_rsa";

my $helper = {};

check_and_update_cache($cachefile,$servername,$nmondir,$ssh_idfile,$debug);

open(NMONFILE, $cachefile);

foreach $line (<NMONFILE>) {
        if (my ($type,$description,$attrs_str) = $line =~ /^(PAGE),(Paging\s[^,]+),(.+)$/) {
		#PAGE,Paging azh-550t-1,faults,pgin,pgout,pgsin,pgsout,reclaims,scans,cycles

		my @attrs = split(/,/,$attrs_str);

		my $i=0;
		foreach $attr (@attrs) {

			$helper->{$type}->{$i} = $attr;

			print "category: $type - i: $i - attribute: $attr\n" if($debug > 1);

			$i++;
		}
		
	}
        if (my ($type,$values_str) = $line =~ /^(PAGE),T\d{4},(.+)$/) {
		#PAGE,T0001,15587.5,0.0,19.8,0.0,0.0,0.0,0.0,0.0

		print "$line\n" if($debug > 1);


		my @values = split(/,/,$values_str);

		$i=0;
		foreach $value (@values) {
			$attr = $helper->{$type}->{$i};
			print "attr: $attr\n" if($debug > 1);
			
			$attr = lc($attr);
			print "$attr:$value ";
			print "attr/value: $attr: $value\n" if($debug > 1);
			$i++;
		}
	}
}
print "\n";

