#!/usr/bin/perl -w

use Data::Dumper;
use File::stat;
use lib "/srv/www/htdocs/cacti/scripts";
use query_nmon;

if(!exists($ARGV[0])) {
	print "usage:\n\n";
	print "./nmon_poolstats.pl <hostname>\n";
	exit;
}

my $debug = 0;

my $servername = $ARGV[0];

my $nmondir = "/usr/net/bin/nmon/";
my $cachedir = "/var/cache/cacti/";
my $cachefile = $cachedir . $servername;
my $ssh_idfile = "/home/cacti/.ssh/id_rsa";

my $helper = {};

check_and_update_cache($cachefile,$servername,$nmondir,$ssh_idfile,$debug);

open(NMONFILE, $cachefile);

foreach $line (<NMONFILE>) {
        if (my ($type,$description,$attrs_str) = $line =~ /^(POOLS),(Multiple\s[^,]+),(.+)$/) {
		#POOLS,Multiple CPU Pools azh-550t-1,shcpus_in_sys,max_pool_capacity,entitled_pool_capacity,pool_max_time,pool_busy_time,shcpu_tot_time,shcpu_busy_time,Pool_id,entitled

		my @attrs = split(/,/,$attrs_str);

		my $i=0;
		foreach $attr (@attrs) {

			$helper->{$type}->{$i} = $attr;

			print "category: $type - i: $i - attribute: $attr\n" if($debug > 1);

			$i++;
		}
		
	}
        if (my ($type,$values_str) = $line =~ /^(POOLS),T\d{4},(.+)$/) {
		#POOLS,T0001,0,0.00,0.00,0.00,0.00,0.00,0.00,0,0.50

		print "$line\n" if($debug > 1);


		my @values = split(/,/,$values_str);

		$i=0;
		foreach $value (@values) {
			$attr = $helper->{$type}->{$i};
			print "attr: $attr\n" if($debug > 1);
			
			$attr = lc($attr);
			print "$attr:$value ";
			print "attr/value: $attr: $value\n" if($debug > 1);
			$i++;
		}
	}
}
print "\n";

